/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GSLMatrix.cpp
 * Author: skidmarks
 * 
 * Created on December 15, 2017, 2:54 PM
 */

# include <gsl/gsl_matrix_double.h>

#include "GSLMatrix.h"

using namespace gls;

GSLMatrix::GSLMatrix(size_t row, size_t col)             : GLSData(row*col, gslMatrix, (gsl_matrix_alloc(row, col))) { };
GSLMatrix::GSLMatrix(size_t row, size_t col, int calloc) : GLSData(row*col, gslMatrix, (gsl_matrix_calloc(row, col))) { };
GSLMatrix::GSLMatrix(_gsl_matrix_view matrix)            : GLSData( matrix.matrix.size1 * matrix.matrix.size2
                                                         , gslMatrixView
                                                         , &matrix.matrix) { };
GSLMatrix::GSLMatrix(_gsl_matrix_const_view matrix)      : GLSData( matrix.matrix.size1 * matrix.matrix.size2
                                                         , gslMatrixView
                                                         , &matrix.matrix) { };
GSLMatrix::GSLMatrix(const GSLMatrix& orig)              : GLSData(orig.size(), orig.id(), orig.strct()) {};

GSLMatrix::~GSLMatrix() {
   if (id() == gslMatrix) gsl_matrix_free((gsl_matrix*)strct()); }

   /*******************************************************
    *******************************************************/


/*
   int= GSL_EFAILED
   gcc -DHAVE_INLINE
   GSL_RANGE_CHECK_OFF
   GSL_COO_INTLINE
   gsl_check_range
*/

GSLMatrix   GSLMatrix::submatrix(size_t row, size_t col, size_t rows, size_t cols) {
   return GSLMatrix(gsl_matrix_submatrix((gsl_matrix*)strct(), row, col, rows, cols));
}; // 

GSLMatrix   GSLMatrix::view_vector(gsl_vector * v, size_t rows, size_t cols) {
   return GSLMatrix(gsl_matrix_view_vector(v, rows, cols));
}; // 

GSLMatrix   GSLMatrix::view_vector_with_tda(gsl_vector * v, size_t rows, size_t cols, size_t tda) {
   return GSLMatrix(gsl_matrix_view_vector_with_tda(v, rows, cols, tda));
}; // 


GSLVector   GSLMatrix::subrow(size_t row, size_t offset, size_t n) {
   return GSLVector(gsl_matrix_subrow((gsl_matrix*)strct(), row, offset, n));
}; // 

GSLVector   GSLMatrix::subcolumn(size_t col, size_t offset, size_t n) {
   return GSLVector(gsl_matrix_subrow((gsl_matrix*)strct(), col, offset, n));
}; // 

const GSLMatrix   GSLMatrix::const_submatrix(size_t row, size_t col, size_t rows, size_t cols) {
   return GSLMatrix(gsl_matrix_const_submatrix((gsl_matrix*)strct(), row, col, rows, cols));
}; // 

const GSLMatrix   GSLMatrix::const_view_vector(gsl_vector * v, size_t rows, size_t cols) {
   return GSLMatrix(gsl_matrix_const_view_vector(v, rows, cols));
}; // 

const GSLMatrix   GSLMatrix::const_view_vector_with_tda(gsl_vector * v, size_t rows, size_t cols, size_t tda) {
   return GSLMatrix(gsl_matrix_const_view_vector_with_tda(v, rows, cols, tda));
}; // 

